--[[--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--||--


      #########     ###########     #######    ###########          #######     #         #   ###########     #######     ###########
      #        #    #              #       #        #              #       #    #         #   #              #       #         #
      #         #   #             #                 #             #         #   #         #   #             #                  #
      #        #    #              #                #             #         #   #         #   #              #                 #
      #########     ###########     #######         #             #         #   #         #   ###########     #######          #
      #        #    #                      #        #             #         #   #         #   #                      #         #
      #         #   #                       #       #             #       # #   #         #   #                       #        #
      #        #    #              #       #        #              #       #     #       #    #              #       #         #
      #########     ###########     #######         #               ####### #     #######     ###########     #######          #



                                                              --||(o):|:(o)||--

						  |  Elite Tauren Chieftain (ETC) Module  |

                                                              --||(o):|:(o)||--

                                                                    v1.03

                                                             12th November 2015

							 Copyright 2015 Chris Birch


                                                              --||(o):|:(o)]]--



--------------------------------------------------------------------------------------------------------------------------------------------

local date		= date
local pairs		= pairs
local stringGsub	= string.gsub

local GetGameTime	= GetGameTime
local GetSubZoneText	= GetSubZoneText
local UnitLevel		= UnitLevel

local npcName = "Kar'ilda"
local minBQVersion = 1.04

--------------------------------------------------------------------------------------------------------------------------------------------

local sound = { ["Skillfully done"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleCongratulations01.ogg",
		["Not bad"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleCongratulations02.ogg",
		["Congratulations"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleCongratulations03.ogg",
		["Zug zug flirt"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt01.ogg",
		["Crazy love"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt02.ogg",
		["Men crying flirt"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt04.ogg",
		["You'll do"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt05.ogg",
		["Don't talk"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt06.ogg",
		["No chit chat"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleFlirt07.ogg",
		["Thram'ka"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleHello01.ogg",
		["Hey"]				= "Sound/character/Orc/OrcVocalFemale/OrcFemaleHello02.ogg",
		["Greetings"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleHello03.ogg",
		["IWontForgetThis"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleThankYou01.ogg",
		["Zug zug"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleYes02.ogg",
		["Hmm"]				= "Sound/character/Orc/OrcVocalFemale/OrcFemaleYes03.ogg",
		["UhHuh"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleYes04.ogg",
		["Sigh"]			= "Sound/character/Orc/Female/OrcFemaleSigh01.ogg",
		["D'abu"]			= "Sound/creature/OrcFemaleStandardNPC/OrcFemaleStandardNPCFarewell01.ogg",
		["D'abu-cheer"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleCheer01.ogg",
		["Stay strong!"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleGoodbye01.ogg",
		["Always victorious"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleGoodbye02.ogg",
		["Until next time"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleGoodbye03.ogg",
		["Incoming!"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleIncoming02.ogg",
		["Chop hand off"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemalePissed01.ogg",
		["Feeling feminine"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemalePissed03.ogg",
		["Chest waxed"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemalePissed05.ogg",
		["Gotta do a crap"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemalePissed06.ogg",
		["raspberry1"]			= "Sound/character/Orc/OrcVocalFemale/OrcFemaleRaspberry01.ogg",
		["raspberry2"]			= "Sound/character/BloodElf/BloodElfFemaleRaspberry01.ogg",			-- loud and proud
		["raspberry3"]			= "Sound/character/BloodElf/BloodElfMaleRaspberry01.ogg",			-- huge sound
		["raspberry4"]			= "Sound/character/Draenei/DraeneiMaleRaspberry01.ogg",
		["raspberry5"]			= "Sound/character/Dwarf/DwarfVocalFemale/DwarfFemaleRaspberry01.ogg",
		["raspberry6"]			= "Sound/character/Gnome/GnomeVocalMale/GnomeMaleRaspberry01.ogg",		-- tight, higher pitched
		["raspberry7"]			= "Sound/character/NightElf/NightElfVocalMale/NightElfMaleRaspberry01.ogg",
		["raspberry8"]			= "Sound/character/PCGoblinMale/VO_PCGoblinMale_Raspberry01.ogg",
		["raspberry9"]			= "Sound/character/PCPandarenMale/VO_PCPandarenMale_Raspberry01.OGG",
		["raspberry10"]			= "Sound/character/PCWorgenMale/VO_PCWorgenMale_Raspberry01.ogg",		-- loud and proud
		["raspberry11"]			= "Sound/character/Gnome/GnomeVocalFemale/GnomeFemaleRaspberry01.ogg",		-- Sputtering
		["raspberry12"]			= "Sound/character/Human/HumanVocalMale/HumanMaleRaspberry01.ogg",		-- Nice finish to the previous one
		["raspberry13"]			= "Sound/character/Gnome/GnomeVocalMale/GnomeMaleRaspberry01.ogg",		-- Tightly squeezed out
		["Anything for friend"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleYoureWelcome02.ogg",
		["Roar"]			= "Sound/character/Orc/OrcVocalFemale/VO_PCOrcFemaleRoar01.ogg",
		["PowerOfTheHorde"]		= "Sound/Music/zonemusic/DMF_L70ETC01.mp3",
		["Yawn"]			= "Sound/character/Orc/Female/OrcFemaleYawn01.ogg",
		["For Durotar!"]		= "Sound/character/Orc/OrcVocalFemale/OrcFemaleCheer02.ogg",
		["For the Horde!"]		= "Sound/creature/OrcFemaleStandardNPC/OrcFemaleStandardNPCFarewell03.ogg",
		["Glory to the Horde!"]		= "Sound/creature/OrcFemaleStandardNPC/OrcFemaleStandardNPCGreeting06.ogg",
		["Lok'tar"]			= "Sound/creature/OrcFemaleShamanNPC/OrcFemaleShamanNPCGreeting02.ogg",
		["Mok'ra"]			= "Sound/creature/OrcFemaleStandardNPC/OrcFemaleStandardNPCGreeting01.ogg",
		["Strength and Honour"]		= "Sound/creature/OrcFemaleStandardNPC/OrcFemaleStandardNPCGreeting02.ogg",
}

--------------------------------------------------------------------------------------------------------------------------------------------

local speech = {

	["1"]	=	"Greetings! Taraezor said you'd be around here, although you were easy to find, smelling of ~r~ and "..
			"all.|n|n"..
			"(taints the air with a tail end terror)|n|n"..
			"Darn that Durotar swine meat went down well.|n|n"..
			"Anyway Taraezor said you're a fan of The Elite Tauren "..
			"Chieftain. Any fan of Sig and co is a friend of mine ~p~!|n|n"..
			"My name is " .. npcName .. ", zug zug with that?|n|n"..
			"So... Silvermoon City, Darkmoon Faire , Grim Guzzler in the Blackrock Depths, and the World's End Tavern. "..
			"That's about it. Anytime you're in the area I'll direct you to where they hang out.|n|n"..
			"Man. I think that boar meat's comin back on me. I gotta hit the can. Anyone have a hearthstone?",

	["2"]	=	"Zug zug ~p~. The World's End Tavern in Shattrath City is where the Elite Tauren Chieftain "..
			"perform every four hours, at 2pm, then 6pm and so on.~f~"..
			"You gotta see Sig Nicious bust out a face melter with his incredible axe, erm, guitar. Man, he's got "..
			"the rhythm ~p~! Want one? Try the Black Market Auction House ~p~, but only useful for DK's, Pallys "..
			"and Warriors. Yeah, rest of his gear is Pally Tier 6.|n|n"..
			"(craftily cuts a cranky custard curdler)|n|n"..
			"Darn that Monstrous Kaliri was good...|n|n"..
			"Don't forget to cheer them, they'lll reward you! Storm! Black clouds fill the sky! Earth! I hear my "..
			"battle cry! Fire! Thunder we'll bring fourth! Death! From the power of the Horde!",

	["2xf1"] =	" They *might* be on soon!|n|n",
	["2xf2"] =	" They *might* be on RIGHT NOW!|n|n",
	["2xf3"] =	"|n|n",

	["3"] 	=	"Congratulations, ~p~ the Darkmoon Faire is in town and that means The Elite Tauren Chieftain "..
			"perform every hour on the hour on the stage near the Darkmoon docks~f~|n|n"..
			"You have gotta see Chief Thunder-Skins dual wield a pair of \"Herald of Woe\" drum sticks. Badass!|n|n"..
			"And Mai'Kyl's bass you'll never find anywhere, ever! Is he wearing shoes ~p~?|n|n"..
			"Oh... you had me at zug zug Samuro with your crazy Tier 6 Onslaught gear!|n|n"..
			"Whooooo! I'll give you crazy love Samuro!|n|n"..
			"(breaks the wind barrier)|n|n"..
			"Darn, it's not just the rogues who are doing it from behind.",

	["3xf1"] =	". Hurry, they're on soon!",
	["3xf2"] =	". HURRY!!! They're on!",
	["3xf3"] =	".",

	["4"]	=	"Greetings ~p~! You've found the mountain. Just follow the entrance until you are inside and can see the larva.",

	["5"] 	=	"Hey ~p~, the Elite Tauren Chieftain are over in Silvermoon City. It's where they hang between gigs "..
			"and generally soak up the adulations of fans who make the pilgrimage to there.|n|n"..
			"(blasts the booty bassoon)|n|n"..
			"Darn fine franks and beans I had over Redridge way before...|n|n"..
			"I'll see you over there ~p~, just gonna farm myself a few Feral Dragonhawk Hatchling eggs.|n|n"..
			"Stay strong! May you always be victorious!",

	["6"] 	=	"Not bad ~p~, you've made it this far. The Elite Tauren Chieftain are right near the entrance "..
			"to Silvermoon City. Straight after entering turn right and at about 76.6, 81.5...|n|n"..
			"(butt bombs)|n|n"..
			"Darn those Feral Dragonhawk Hatchling eggs...|n|n"..
			"Band are chillin' on the balcony, crew are hangin' below. Man they are all pumped, ready to "..
			"Terran up the night and Raise Some Hell come Nightfall as Warriors of Azeroth.|n|n"..
			"(cuts a cheesy cheek screecher)|n|n"..
			"I feel very feminine, and I'll beat the crap out of anyone who disagrees!",

	["7"] 	=	"Skillfully done ~p~, now over here! Can you see me?|n|n"..
			"(lets rip a ripe rump ripper)|n|n"..
			"Darn Monstrous Kaliri Eggs, not worth the trouble no matter what you achieve...|n|n"..
			"~f1~ince when do taverns not have signs? Anyway, I'm told the coordinates are about 73.7, 33.1. "..
			"Due east from the centre, a little north.|n|n"..
			"(roars another rectal rattler)|n|n~f2~",

	["7xf1"] =	"Hurry, they're on soon! S",
	["7xf2"] =	"HURRY!!! THEY'RE ON! S",
	["7xf3"] =	"S",
	["7xf4"] =	"Ooooh, that pickled pig's snout from Bron in Durotar, it wasn't good...|n|n",
			"You're a little early, so grab a drink from Kylene and head on over to the stage area. If you wanna "..
			"you can checkout Chief Thunder Skins awesome rig!|n|n",
	["7xf5"] =	"Hmm cheesy, very cheesy. I mean, what did Haris Pilton ever do? What would I achieve with *that* as a "..
			"handbag?|n|n"..
			"Had to go ~p~, until next time!|n|n"..
			"And don't forget ~p~, get between me and my food and you'll lose a hand!",
	["7xf6"] =	"I really need another cabbage juice to wash that down.|n|n"..
			"I'll drop by again to remind you ~p~, anything for a friend. D'abu!",

	["8"] 	=	"(Loud farting sound)|n|n"..
			"That was just breakfast saying \"Hellooo Azeroth!\"...|n|n"..
			"|n|n|n|n|n|n|n|n|n|n|n"..
			"\"I am the son of the wind and rain|n"..
			"Thunder beckons and I heed the call|n"..
			"And if die upon this day|n"..
			"In battle I will fall|n"..
			"Hear me brothers, gather up the wolves|n"..
			"To battle we will ride|n"..
			"War drums echo the beating heart|n"..
			"Pounding from inside\"",

	["9"]	=	"D'abu ~p~.|n|n"..
			"That centre structure, supported by chains, is where we are going. To get to it, climb the path you "..
			"are on to the highest point. Jump up on the chain and follow it down to a platform high above the "..
			"centre of the lava.|n|n"..
			"There'll be two doorways, both of which lead to the same chamber. So go on in!",

	["10"]	=	"Just walk through \"Forgewright's Tomb\", down the ramp, past the tomb, and down another ramp. "..
			"You will be on a ledge overlooking \"The Molten Span\".",

	["11"]	=	"Assuming you did exactly as I said then you are standing on a narrow ledge.|n|n"..
			"Follow the ledge down, it's the only way you can go actually. See that chain? It is safe to walk "..
			"across.|n|n"..
			"There is a doorway to the right as you approach Lothos. Walk through it. If you check your map "..
			"you will see that it's a no brainer from here to the Blackrock Depths entrance.|n|n"..
			"Wait in the \"Detention Block\", just past the entrance.",

	-- Unused
	["12"] =	"Okay do your own thing then. You're on your own kiddo! Just a moment... hold on... Ah now...|n|n"..
			"(a veritable volley of thunder)|n"..
			"(a cacophony of excessive exhaust)|n"..
			"(a robust riposte of klaxons)|n"..
			"(a flowering of airborne abscesses)|n"..
			"(a veritable volley of vastly vile vaporous vesications)",

	["13"] =	"Mok'ra! Well the Grim Guzzler is where the Elite Tauren Chieftain play at ~h~.|n|n"..
			"I can also see you're busy so I'll come back another time when you and maybe some friends walk "..
			"in through the entrance or use a Direbrew's Remote to get here or when it's only you left in this "..
			"group.|n|n"..
			"For Durotar!",

	["14"] 	=	"Mok'ra, ~p~! The Grim Guzzler is where the Elite Tauren Chieftain play at ~h~.|n|n"..
			"They play for three to four minutes. A player able to avoid all the hostile Dark Irons "..
			"and Elementals will need about four minutes at normal running speed to reach the Grim "..
			"Guzzler from here.|n|n"..
			"If that sounds good to you then go for it ~p~! I can lead the way...|n|n"..
			"We're going to go up into \"The Domicile\". See the \"Abandoned Mole Machine\" over there? Hit the button "..
			"labeled \"Into the Domicile\" when you are ready.|n|n"..
			"Yuka Screwspigot can help with repairs beforehand. She's alright for a goblin.|n|n"..
			"~f~",

	["14h1"] =	"And ignore that silly troll waving at you - he waves at anything. He's a shoveltusk flank short of a Great "..
			"Feast if you catch my drift.",
	["14a1"] =	"And ignore the silly dolt in the centre there. He's a shoveltusk flank short of a Great "..
			"Feast if you catch my drift.",

	["15"]	=	"Nicely spotted ~n~. I won't forget this.|n|n"..
			"Now, how's an orc to blend in around here?...|n|n"..
			"Ah yes! Beer goggles!",

	["16"]	=	"Lok'tar, ~p~! Good to see you could get yourself to the Grim Guzzler.|n|n"..
			"The band officially play at ~h~ but even then, did you know that if you come by Direbrew's Remote "..
			"then if you have a chat with Mizli or Ognip, the roadies, they might just accommodate your wish to "..
			"see them play at any time.|n|n",

	["17"]	=	"Take a look around ~p~ and you'll see Chief Thunder Skin's drum set up, ready for their gig "..
			"at ~h~.|n|n"..
			"Plugger Spazzring on the top level sells his excellent \"Plugger's Blackrock Ale\". Goes great with "..
			"Rock-Salted Pretzels!|n|n"..
			"Watchout for Mistress Nagmara, her whip really hurts. Damn, she said to say \"hammered\" if it hurts "..
			"too much but I'd had so many of Plugger's Ales I couldn't remember what to say...",

	["18"]	=	"Zug zug, you made it as far as \"The Domicile\". Even really low level adventurers can get this far alone "..
			"so it's no grand achievement.|n|n"..
			"Look at your map. We're taking the exit at the southern corner. Or, from the mole machine, turn left "..
			"and go forward, veering right.|n|n"..
			"You'll see a bridge. Cross it and enter the \"Shrine of Thaurissan\".",

	["19"]	=	"See the \"Elemental Gate\"? Take the immediate right turn up the ramp, into the \"Ring of the "..
			"Law\".|n|n|n|n|n|n|n|n|n|n|n|n|n|n|n|n|n|n|n"..
			"~p~, ~f~",
			
	["19xf1"] =	"I was wondering, as one of those Alliance dog things, when you go into tree form, do you "..
			"pee on yourself?",											-- for worgen druids
	["19xf2"] =	"careful going into tree form in this place. Every dog will be after you for a pee!",			-- Other druids
	["19xf3"] =	"careful going into ghost wolf form. You won't find a tree to pee on in this place!",			-- Shaman
	["19xf4"] =	"when you go a bit \"lupine\", it must be hard to find a tree in here to pee against?",			-- other worgen
	["19xf5"] =	"no greenery, no trees in this place... Well aside from an orc or two... oh the odd goblin...",		-- Others

	["20"]	=	"Thram'ka ~p~, you have done well so far even for a ~r~ such as you.|n|n"..
			"The exit to the Ring of the Law is exactly on the other side. Keep going until you reach the \"East "..
			"Garrison\".|n|n"..
			"If there was some greenery for me to blend in or some wind blowing I'd feel at home in here. Alas...",

	["21"]	=	"The \"East Garrison\" has two levels, divided by a ramp. The lower level has a huge cogwheel high up "..
			"in the air. It has an anvil motif. When you click on the mechanism at its base, the cogwheel spins, "..
			"opening a gate separating this area from the \"West Garrison\".|n|n"..
			"The upper level leads into the \"Ring of the Law\" or to the \"West Garrison\".|n|n"..
			"The door on the lower level leads through to the \"Detention Block\". A handy shortcut to the "..
			"exit, a mole machine and a repairer and vendor.",

	["22"]	=	"Zug zug ~p~, just keep going.|n|n"..
			"Take a right when you see it. That'll put you into \The Manufactory\".",

	["23"]	=	"The exit is on the right side. Take the exit, cross the bridge and up the ramp into the \"Grim Guzzler\".",

	["24"]	=	"(let's fly with a fearsome flurry of flatulence)|n|n"..
			"Man, that Aged Dalaran Limburger cheese, gotta cut it out.|n|n"..
			"Checkout that skull-axe Bergrisst uses. An \"Arcanite Ripper\"! Wow! You know you can only get "..
			"that from the Black Market Auction House. What a face ripper! Man he carves them up with it! "..
			"Love the Vengeful Gladiator's Regalia too...|n|n"..
			"(deals a dastardly death duster)|n|n"..
			"Ohh, I need to get my chest waxed again!|n|n"..
			"Buff me Bergrisst! It's me, ".. npcName.."! Buff *me*!|n|n"..
			"(cheers)|n|n"..
			"Darn I love it when he does that. He buffs me so hard he gets me turned up to 11!",

	["25"]	=	"The Elite Tauren Chieftain play in the Grim Guzzler at ~h~. I wouldn't bother visiting at "..
			"any other time. The performance is not to be missed and the Grim Guzzler patrons really "..
			"get into it!|n|n"..
			"Taraezor did mention that if you need that explained then you should go see him.|n|n"..
			"If you do head on over to Blackrock Mountain then I will follow you through and guide you "..
			"to the \"GG\". It can be a little tricky.|n|n"..
			"By the way, the gigs at the Worlds End Tavern in Shatt' occur every *four* hours, 2pm, 6pm, "..
			"and so on. 24/7 ~p~, 24/7!|n|n"..
			"Strength and Honour!",

}

--------------------------------------------------------------------------------------------------------------------------------------------

local portrait = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Kar'ilda"

local brd_instructedEntrance, factionText = false, ""

local BESTQUEST_ETC_SHATTRATHNOTREADY = "Shattrath not ready"
local BESTQUEST_ETC_BRD_MISSED	= "Missed BRD"

if not BestQuestDB["ETC"] then BestQuestDB["ETC"] = {} end
BestQuestDB["ETC"].npcName = npcName

--------------------------------------------------------------------------------------------------------------------------------------------

-- ==========
--
-- Time Zones
--
-- ==========

local server = { 	["Alexstrasza"] = "Central",		["Alleria"] = "Central",		["Blackhand"] = "Central",
			["Dalaran"] = "Eastern",		["Dentarg"] = "Central",		["Galakrond"] = "Central",
			["Garona"] = "Central",			["Ghostlands"] = "Central",		["Goldrinn"] = "Brazil",
			["Hellscream"] = "Central",		["Illidan"] = "Central",		["Kael'thas"] = "Central",
			["Khadgar"] = "Central",		["Kirin Tor"] = "Central",		["Nemesis"] = "Brazil",
			["Ravencrest"] = "Central",		["Sentinels"] = "Central",		["Steamwheedle Cartel"] = "Central",
			["Stormreaver"] = "Central",		["Terokkar"] = "Central",		["Thrall"] = "Central",
			["Uldaman"] = "Central",		["Whisperwind"] = "Central",		["Zangarmarsh"] = "Central",
			["Agammaggan"] = "Central",		["Andorhal"] = "Pacific",		["Archimonde"] = "Central",
			["Azralon"] = "Brazil",			["Azuremyst"] = "Central",		["Baelgun"] = "Pacific",
			["Blackwing Lair"] = "Central",		["Burning Legion"] = "Central",		["Coilfang"] = "Pacific",
			["Dalvengyr"] = "Pacific",		["Dark Iron"] = "Pacific",		["Deathwing"] = "Mountain",
			["Demon Soul"] = "Pacific",		["Dethecus"] = "Central",		["Detheroc"] = "Central",
			["Doomhammer"] = "Pacific",		["Emerald Dream"] = "Central",		["Eredar"] = "Eastern",
			["Executus"] = "Pacific",		["Gnomeregan"] = "Pacific",		["Gorefiend"] = "Central",
			["Greymane"] = "Central",		["Haomarush"] = "Central",		["Jaedenar"] = "Central",
			["Kalecgos"] = "Pacific",		["Lethon"] = "Central",			["Lightninghoof"] = "Central",
			["Maelstrom"] = "Central",		["Moonrunner"] = "Pacific",		["Ravenholdt"] = "Central",
			["Sargeras"] = "Central",		["Scilla"] = "Pacific",			["Shadowmoon"] = "Central",
			["Shattered Halls"] = "Pacific",	["Shattered Hand"] = "Pacific",		["Spinebreaker"] = "Central",
			["Staghelm"] = "Central",		["Tanaris"] = "Central",		["The Underbog"] = "Central",
			["The Venture Co"] = "Central",		["Tol Barad"] = "Brazil",		["Twisting Nether"] = "Central",
			["Ursin"] = "Pacific",			["Wildhammer"] = "Central",		["Zuluhed"] = "Pacific",
			["Altar of Storms"] = "Eastern",	["Alterac Mountains"] = "Eastern",	["Anetheron"] = "Eastern",
			["Anvilmar"] = "Central",		["Argent Dawn"] = "Eastern",		["Arthas"] = "Eastern",
			["Azgalor"] = "Central",		["Azshara"] = "Central",		["Balnazzar"] = "Eastern",
			["Black Dragonflight"] = "Eastern",	["Bleeding Hollow"] = "Eastern",	["Blood Furnace"] = "Eastern",
			["Bloodhoof"] = "Eastern",		["Dawnbringer"] = "Central",		["Destromath"] = "Central",
			["Durotan"] = "Eastern",		["Duskwood"] = "Eastern",		["Elune"] = "Eastern",
			["Exodar"] = "Eastern",			["Gallywix"] = "Brazil",		["Gilneas"] = "Eastern",
			["Gorgonnash"] = "Eastern",		["Grizzly Hills"] = "Eastern",		["Gul'dan"] = "Eastern",
			["Lothar"] = "Eastern",			["Madoran"] = "Central",		["Magtheridon"] = "Eastern",
			["Malfurion"] = "Eastern",		["Mannoroth"] = "Eastern",		["Medivh"] = "Eastern",
			["Nazjatar"] = "Eastern",		["Skullcrusher"] = "Eastern",		["Stormrage"] = "Eastern",
			["The Forgotten Coast"] = "Eastern",	["The Scryers"] = "Eastern",		["Thunderlord"] = "Central",
			["Trollbane"] = "Eastern",		["Undermine"] = "Central",		["Warsong"] = "Eastern",
			["Ysera"] = "Eastern",			["Ysondre"] = "Eastern",		["Zul'jin"] = "Eastern",
			["Aerie Peak"] = "Pacific",		["Aggramer"] = "Central",		["Area 52"] = "Eastern",
			["Auchindoun"] = "Eastern",		["Blade's Edge"] = "Central",		["Burning Blade"] = "Eastern",
			["Cho'gall"] = "Central",		["Drakkari"] = "Zona Centro",		["Earthern Ring"] = "Eastern",
			["Eonar"] = "Eastern",			["Fizzcrank"] = "Central",		["Icecrown"] = "Central",
			["Kargath"] = "Eastern",		["Kel'Thuzard"] = "Mountain",		["Laughing Skull"] = "Central",
			["Lightning's Blade"] = "Eastern",	["Llane"] = "Eastern",			["Mal'Ganis"] = "Central",
			["Malygos"] = "Central",		["Norgannon"] = "Eastern",		["Onyxia"] = "Pacific",
			["Quel'Thalas"] = "Zona Centro",	["Ragnaros"] = "Zona Centro",		["Thunderhorn"] = "Central",
			["Turalyon"] = "Eastern",		["Velen"] = "Eastern",			["Blackrock"] = "Pacific",
			["Farstriders"] = "Pacific",		["Frostwolf"] = "Pacific",		["Kil'Jaeden"] = "Pacific",
			["Kilrogg"] = "Pacific",		["Nazgrel"] = "Central",		["Nesingwary"] = "Central",
			["Proudmoore"] = "Pacific",		["Quel'dorei"] = "Central",		["Sen'jin"] = "Central",
			["Silver Hand"] = "Pacific",		["Thorium Brotherhood"] = "Pacific",	["Tichondrius"] = "Pacific",
			["Vashj"] = "Pacific",			["Vek'nilash"] = "Central",		["Winterhoof"] = "Pacific",
			["Aegwynn"] = "Central",		["Anub'arak"] = "Central",		["Bladefist"] = "Central",
			["Bonechewer"] = "Central",		["Chromaggus"] = "Central",		["Crushridge"] = "Central",
			["Daggerspine"] = "Central",		["Eitrigg"] = "Central",		["Garithos"] = "Central",
			["Garrosh"] = "Eastern",		["Gurubashi"] = "Central",		["Hakkar"] = "Central",
			["Hyjal"] = "Pacific",			["Korgath"] = "Central",		["Kul Tiras"] = "Central",
			["Misha"] = "Central",			["Muradin"] = "Central",		["Nathrezim"] = "Central",
			["Nordrassil"] = "Central",		["Rexar"] = "Central",			["Runetotem"] = "Central",
			["Shu'halo"] = "Central",		["Smoulderthorn"] = "Central",		["Uther"] = "Central",
			["Antonidas"] = "Pacific",		["Azjol-Nerub"] = "Mountain",		["Bloodscalp"] = "Mountain",
			["Boulderfist"] = "Mountain",		["Bronzebeard"] = "Pacific",		["Cairne"] = "Mountain",
			["Cenarius"] = "Pacific",		["Cenarion Circle"] = "Pacific",	["Darkspear"] = "Mountain",
			["Draenor"] = "Pacific",		["Dragonblight"] = "Pacific",		["Draka"] = "Pacific",
			["Dunemaul"] = "Mountain",		["Echo Isles"] = "Pacific",		["Fenris"] = "Pacific",
			["Khaz Modan"] = "Mountain",		["Lightbringer"] = "Pacific",		["Maiev"] = "Mountain",
			["Perenolde"] = "Mountain",		["Shandris"] = "Pacific",		["Sisters of Elune"] = "Pacific",
			["Stonemaul"] = "Mountain",		["Suramar"] = "Pacific",		["Uldum"] = "Pacific",
			["Wyrmrest Accord"] = "Pacific",	["Akama"] = "Pacific",			["Arathor"] = "Pacific",
			["Blackwater Raiders"] = "Mountain",	["Borean Tundra"] = "Pacific",		["Darrowmere"] = "Pacific",
			["Dragonmaw"] = "Pacific",		["Drak'Tharon"] = "Eastern",		["Drak'thul"] = "Pacific",
			["Drenden"] = "Pacific",		["Eldre'Thalas"] = "Eastern",		["Feathermoon"] = "Pacific",
			["Firetree"] = "Eastern",		["Frostmane"] = "Central",		["Hydraxis"] = "Mountain",
			["Korialstrasz"] = "Eastern",		["Malorne"] = "Eastern",		["Mok'Nathal"] = "Pacific",
			["Moon Guard"] = "Central",		["Mug'thol"] = "Pacific",		["Ner'zhul"] = "Pacific",
			["Rivendare"] = "Eastern",		["Mok'Nathal"] = "Pacific",		["Scarlet Crusade"] = "Pacific",
			["Shadow Council"] = "Mountain",	["Shadowsong"] = "Pacific",		["Silvermoon"] = "Pacific",
			["Skywall"] = "Pacific",		["Spirestone"] = "Pacific",		["Stormscale"] = "Pacific",
			["Terenas"] = "Mountain",		["Tortheldrind"] = "Central",		["Windrunner"] = "Pacific",
			["Aman'Thul"] = "Australia",		["Barthilas"] = "Australia",		["Caelestrasz"] = "Australia",
			["Dath'Remar"] = "Australia",		["Dreadmaul"] = "Australia",		["Frostmourne"] = "Australia",
			["Khaz'goroth"] = "Australia",		["Nagrand"] = "Australia",		["Thaurissan"] = "Australia",
			["Gundrak"] = "Australia",		["Jubei'Thos"] = "Australia",		["Saurfang"] = "Australia",
}
setmetatable(server,{__index=function()return"Unknown"end})

local zones = { ["Pacific"] = { ["ordStart"] = 2, ["monStart"] = 3, ["ordFin"] = 1, ["monFin"] = 11, ["offStd"] = -8, ["offDay"] = -7},
		["Mountain"] = { ["ordStart"] = 2, ["monStart"] = 3, ["ordFin"] = 1, ["monFin"] = 11, ["offStd"] = -7, ["offDay"] = -6},
		["Zona Centro"] = { ["ordStart"] = 1, ["monStart"] = 4, ["ordFin"] = 5, ["monFin"] = 10, ["offStd"] = -6, ["offDay"] = -5},
		["Central"] = { ["ordStart"] = 2, ["monStart"] = 3, ["ordFin"] = 1, ["monFin"] = 11, ["offStd"] = -6, ["offDay"] = -5},
		["Eastern"] = { ["ordStart"] = 2, ["monStart"] = 3, ["ordFin"] = 1, ["monFin"] = 11, ["offStd"] = -5, ["offDay"] = -4},
		["Brazil"] = { ["ordStart"] = 3, ["monStart"] = 10, ["ordFin"] = 3, ["monFin"] = 2, ["offStd"] = -3, ["offDay"] = -2},
		["Australia"] = { ["ordStart"] = 1, ["monStart"] = 10, ["ordFin"] = 1, ["monFin"] = 4, ["offStd"] = 10, ["offDay"] = 11}
}

local function IsLeapYear(year)
	return year % 4 == 0 and ( year % 100 ~= 0 or year % 400 == 0 )
end

local daysInMonth = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }

local function DaysInMonth( month, year )
	if month == 2 and IsLeapYear( year ) then
		return 29
	else
		return daysInMonth[month]
	end
end

local function IsDaylightSavings( zone, year, month, day, dow)

	local daylightSavings, firstSunday, testSunday = "", 0, 0

	if ( zones[zone].monStart < zones[zone].monFin ) then
		if ( month < zones[zone].monStart ) or ( month > zones[zone].monFin ) then
			daylightSavings = "N"
		elseif ( month > zones[zone].monStart ) and ( month < zones[zone].monFin ) then
			daylightSavings = "Y"
		end
	else
		-- i.e. Australia, Brazil
		if ( month > zones[zone].monStart ) or ( month < zones[zone].monFin ) then
			daylightSavings = "Y"
		elseif ( month < zones[zone].monStart ) and ( month > zones[zone].monFin ) then
			daylightSavings = "N"
		end
	end
	if daylightSavings == "" then
		firstSunday = ( ( 7 - dow ) + day ) - ( floor( ( ( 7 - dow ) + day ) / 7 ) * 7 )
		if firstSunday == 0 then firstSunday = 7 end
		if ( month == zones[zone].monStart ) then
			testSunday = firstSunday + ( ( zones[zone].ordStart - 1 ) * 7 )
		else
			testSunday = firstSunday + ( ( zones[zone].ordFin - 1 ) * 7 )
		end
		if testSunday > DaysInMonth( month, year ) then
			testSunday = testSunday - 7
		end
		if ( month == zones[zone].monStart ) then
			if day < testSunday then
				daylightSavings = "N"
			else
				daylightSavings = "Y"
			end
		else
			if day < testSunday then
				daylightSavings = "Y"
			else
				daylightSavings = "N"
			end
		end
	end
	return daylightSavings
end

local function GrimGuzzlerPerformanceTime()

	local zone = server[GetRealmName()]

	if zone == "Unknown" then
		return "an unknown time, once every 24 hours"
	end

	local ggYear = tonumber(date("%Y"))
	local ggMonth = tonumber(date("%m"))
	local ggDay = tonumber(date("%e"))
	local ggDoW = tonumber(date("%u"))	-- Sunday = 7
	local ggHour, ggMinute = GetGameTime()	-- 24 hour clock

	-- Fortunately, the Grim Guzzler is at 8pm so all of the USA time zones will match for date and Summer Time
	-- Mexico only needs to check date, not the hour. Australia too as the difference is so huge, but add 1 day
	-- Brazil players probably don't use this English only AddOn

	if zone == "Australia" then
		ggDay = ggDay + 1
		if ggDay > DaysInMonth( ggMonth, ggYear) then
			ggDay = 1
			ggMonth = ggMonth +1
			if ggMonth > 12 then
				ggYear = ggYear + 1
				ggMonth = 1
			end
		end
		ggDoW = ggDoW + 1
		if ggDoW > 7 then ggDoW = 1 end
	end

	local daylightSavingsLocal = IsDaylightSavings( zone, ggYear, ggMonth, ggDay, ggDoW)
	local daylightSavingsPacific = IsDaylightSavings( "Pacific", ggYear, ggMonth, ggDay, ggDoW)

	local localGrimGuzzlerGigTime = 0
	if daylightSavingsLocal == "Y" then
		if daylightSavingsPacific == "Y" then
			localGrimGuzzlerGigTime = 20 - ( zones["Pacific"].offDay - zones[zone].offDay )
		else
			localGrimGuzzlerGigTime = 20 - ( zones["Pacific"].offStd - zones[zone].offDay )
		end
	else
		if daylightSavingsPacific == "Y" then
			localGrimGuzzlerGigTime = 20 - ( zones["Pacific"].offDay - zones[zone].offStd )
		else
			localGrimGuzzlerGigTime = 20 - ( zones["Pacific"].offStd - zones[zone].offStd )
		end
	end
	if localGrimGuzzlerGigTime >= 24 then			-- Australia
		localGrimGuzzlerGigTime = localGrimGuzzlerGigTime - 24
	end

	if ( localGrimGuzzlerGigTime > 12 ) or ( localGrimGuzzlerGigTime == 0 ) then
		if ( localGrimGuzzlerGigTime > 17 ) or ( localGrimGuzzlerGigTime == 0 ) then
			return tostring( (localGrimGuzzlerGigTime - 12).."pm, every evening")
		else
			return tostring( (localGrimGuzzlerGigTime - 12).."pm every afternoon")
		end
	elseif ( localGrimGuzzlerGigTime == 12) then
		return "12 noon, every day"
	else
		return tostring( localGrimGuzzlerGigTime.."am every day")
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------

-- ============
--
-- Grim Guzzler
--
-- ============

local function GrimGuzzler()
----------------------------

	if BestQuestDB["ETC"]["The Molten Span 2"] and BestQuestDB["ETC"]["East Garrison"] and BestQuestDB["ETC"]["Grim Guzzler"] then return end
	-- no need for help as the player has clearly walked there before, even if some parts below didn't trigger

	-- Note: Player may have been summoned. e.g. by Warlock
	-- Note: Band plays for only 3-4 minutes

	-- Reminder notes: Difference between GetSubZoneText() and GetMinimapZoneText() as follows:
	-- The narrow rectangle above the minimap displays the subzone, if there is one. If none then the zone name is shown
	-- GetMinimapZoneText() returns what is displayed - subzone or if none the zone
	-- GetSubZoneText() is the subzone or "" if no subzone

	local subZone = GetSubZoneText()
	-- print("sub:"..subZone..":mini:"..GetMinimapZoneText()..":")

	if (subZone == "") and (GetMinimapZoneText() == "Blackrock Mountain") and (BestQuestDB["ETC"]["Blackrock Mountain"] == nil) then

		-- right outside the mountain, in the Searing Gorge or Burning Steppes. But previously inside?

		if BestQuestDB["ETC"]["The Molten Span 1"] or BestQuestDB["ETC"]["The Molten Span 2"] then
			BestQuestDB["ETC"]["Blackrock Mountain"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 4" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 4"] = { ["dialogue"] = speech["4"], ["portrait"] = portrait, ["greeting"] = sound["Greetings"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\BlackrockEntrance",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-120", ["alpha"] = "1", ["DBPrimary"] = "ETC", ["DBLabel"] = "Blackrock Mountain"}
		end
	end

	-- Overlooking The Molten Span - the interior cavern. Careful, player must come into this sub-zone TWICE

	if (subZone == "The Molten Span") and (BestQuestDB["ETC"]["The Molten Span 1"] == nil) then

		-- But has the player made it through to the entrance previously, somehow

		if BestQuestDB["ETC"]["The Molten Span 2"] then 
			BestQuestDB["ETC"]["The Molten Span 1"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 9" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 9"] = { ["dialogue"] = speech["9"], ["portrait"] = portrait, ["greeting"] = sound["D'abu"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\TheMoltenSpan1",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-120", ["alpha"] = "0.8", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Molten Span 1"}
		end
	end

	if (subZone == "Forgewright's Tomb") and (BestQuestDB["ETC"]["Forgewright's Tomb"] == nil) then

		-- there are TWO Molten Span passes and player should be doing just the second of these. Clear the second one so player can
		-- receive a reminder

		if BestQuestDB["ETC"]["The Molten Span 2"] then BestQuestDB["ETC"]["The Molten Span 2"] = nil end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 10" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 10"] = { ["dialogue"] = speech["10"], ["portrait"] = portrait,
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\ForgewrightsTomb",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-125", ["alpha"] = "1", ["DBPrimary"] = "ETC", ["DBLabel"] = "Forgewright's Tomb"}
		end
	end

	if (subZone == "The Molten Span") and (BestQuestDB["ETC"]["The Molten Span 2"] == nil) and (BestQuestDB["ETC"]["Forgewright's Tomb"]) then

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 11" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 11"] = { ["dialogue"] = speech["11"], ["portrait"] = portrait,
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\TheMoltenSpan2",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["relativePointY"] = "-120", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Molten Span 2"}
		end
	end

	-- Remainder of the logic occurs inside the instance. At that stage we get a useful MapID to test for this. Previously, WoW returned
	-- an invalid mapID as Blackrock Mountain doesn't have its own one. Searing Gorge or Burning Steppes mapID is used by Blizzard

	if (BestQuest_AreaID ~= 704) then return end	-- Blackrock Depths mapID

	-- Careful. On entering, any BQ frame immediately shown will not be seen by the player. Wait for player to walk forward a little.
	-- This causes the subZone to be set too. If standing right at the entrance, it will be an empty string.
	-- Blizzard also wait as well (for their dungeon announcement), so all good

	if subZone == "" then return end

	if (subZone == "Detention Block") then

		if (BestQuestDB["ETC"]["Detention Block"] ~= nil) then return end

		-- Player might be running an instance, solo, or doing this in a party, or whatever

		if (GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) > 1) then

			-- I think that's the only reliable test for a queued instance (LFD)
			-- Once in the LFD instance, player can feasibly be left alone

			if (BestQuestDB["ETC"]["Blackrock Group"] == nil) then

				alreadyQueued = false
				for k,v in pairs(BestQuest_Chat) do
					if k == "ETC 13" then
						alreadyQueued = true
						break
					end
				end
				if not alreadyQueued then
					speech["13"] = stringGsub(speech["13"],"~h~", GrimGuzzlerPerformanceTime())
					BestQuest_Chat["ETC 13"] = { ["dialogue"] = speech["13"], ["portrait"] = portrait, ["greeting"] = sound["Mok'ra"],
							["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\MoleMachine",
							["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
							["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
							["relativePointY"] = "-100", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "Blackrock Group"}
					BestQuest_Chat["ETC 13t1"] = { ["greeting"] = sound["For Durotar!"], ["showing"] = "ETC 13",
							["startTime"] = 0, ["pause"] = 10, ["DBPrimary"] = "ETC", ["DBLabel"] = "Blackrock Group t1"}
				end
			end

			return
		end

		-- To here if solo at the end of a LFD run. Beware: doors may have been opened etc, allowing a shortcut.
		-- Warn players that the band will NOT be playing when they get there. They only play for about 3-4 minutes

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 14" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			if BestQuest_Faction == "Horde" then
				factionText = speech["14h1"]
			else
				factionText = speech["14a1"]
			end
			speech["14"] = stringGsub(speech["14"],"~f~", factionText)
			speech["14"] = stringGsub(speech["14"],"~h~", GrimGuzzlerPerformanceTime())
			BestQuest_Chat["ETC 14"] = { ["dialogue"] = speech["14"], ["portrait"] = portrait, ["greeting"] = sound["Mok'ra"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\MoleMachine",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-100", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "Detention Block"}
		end

	elseif (subZone == "The Domicile ") then		-- Thanks for the typo Blizzard - that extra space had me tricked. Hassle to debug lol

		-- There is another way to here but player would be at the end of a dungeon run or exploring so don't block the dialogue

		if (BestQuestDB["ETC"]["The Domicile"] ~= nil) then return end
		if BestQuestDB["ETC"]["Shrine of Thaurissan"] then				-- player might be back tracking
			BestQuestDB["ETC"]["The Domicile"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 18" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 18"] = { ["dialogue"] = speech["18"], ["portrait"] = portrait, ["greeting"] = sound["Zug zug"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\TheDomicile",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-130", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Domicile"}
		end
	end

	if (subZone == "Shrine of Thaurissan") then

		if (BestQuestDB["ETC"]["Shrine of Thaurissan"] ~= nil) then return end
		if BestQuestDB["ETC"]["Ring of the Law"] then					-- player might be back tracking
			BestQuestDB["ETC"]["Shrine of Thaurissan"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 19" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			local _,englishClass = UnitClass("player")
			if ( BestQuest_Race == "Worgen" ) then
				if ( englishClass == "DRUID" ) then
					factionText = speech["19xf1"]
				else
					factionText = speech["19xf4"]
				end
			elseif englishClass == "DRUID" then
				factionText = speech["19xf2"]
			elseif englishClass == "SHAMAN" then
				factionText = speech["19xf3"]
			else
				factionText = speech["19xf5"]
			end
			speech["19"] = stringGsub(speech["19"],"~f~", factionText)
			BestQuest_Chat["ETC 19"] = { ["dialogue"] = speech["19"], ["portrait"] = portrait,
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\BridgeDomToShrine",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-110", ["alpha"] = "0.8", ["DBPrimary"] = "ETC", ["DBLabel"] = "Shrine of Thaurissan"}
		end
	end

	if (subZone == "Ring of the Law") then

		if (BestQuestDB["ETC"]["Ring of the Law"] ~= nil) then return end
		if BestQuestDB["ETC"]["East Garrison"] then					-- player might be back tracking
			BestQuestDB["ETC"]["Ring of the Law"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 20" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			speech["20"] = stringGsub(speech["20"],"~r~", BestQuest_Race)
			BestQuest_Chat["ETC 20"] = { ["dialogue"] = speech["20"], ["portrait"] = portrait, ["greeting"] = sound["Thram'ka"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\RingOfTheLaw",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-110", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "Ring of the Law"}
		end
	end

	if (subZone == "East Garrison") then

		-- Careful. We have a door leading straight into the Detention Block here. Player might be exploring randomly
		-- The text has been carefully worded so it doesn't matter which way the player is going or coming from
		-- Help the player and show, even if backtracking

		if (BestQuestDB["ETC"]["East Garrison"] ~= nil) then return end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 21" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 21"] = { ["dialogue"] = speech["21"], ["portrait"] = portrait,
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\EastGarrison",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-110", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "East Garrison"}
		end
	end

	if (subZone == "West Garrison") then

		if (BestQuestDB["ETC"]["West Garrison"] ~= nil) then return end
		if BestQuestDB["ETC"]["The Manufactory"] then					-- player might be back tracking
			BestQuestDB["ETC"]["West Garrison"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 22" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 22"] = { ["dialogue"] = speech["22"], ["portrait"] = portrait, ["greeting"] = sound["Zug zug"],
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\BridgeEastToWest",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-135", ["alpha"] = "1", ["DBPrimary"] = "ETC", ["DBLabel"] = "West Garrison"}
		end
	end

	if (subZone == "The Manufactory") then

		if (BestQuestDB["ETC"]["The Manufactory"] ~= nil) then return end
		if BestQuestDB["ETC"]["The Grim Guzzler"] then					-- player might be back tracking
			BestQuestDB["ETC"]["The Manufactory"] = BESTQUEST_NOT_APPLICABLE
			return
		end

		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 23" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			BestQuest_Chat["ETC 23"] = { ["dialogue"] = speech["23"], ["portrait"] = portrait,
					["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\TheManufactory",
					["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
					["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
					["relativePointY"] = "-120", ["alpha"] = "1", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Manufactory"}
		end
	end

	if ( subZone == "The Grim Guzzler" ) then

		-- player might have arrived via a Direbrew Remote. Careful as if this is true and we throw up a dialogue frame, due to loading delays,
		-- the player will NOT see the dialogue
		-- Must use coordinates to see if player in the "remote room". Note that the Thorium Brotherhood supply/trade room at the top level
		-- has overlapping coordinates so a false positive will occur if player arrives there (somehow)
		-- player might have arrived here via Brewfest. Will NOT be in the "remote room". Will be near but facing away from the band

		local inTheRemoteRoom = false
		local xPos, yPos = GetPlayerMapPosition("player")
		local calcY = (-0.86603 * xPos) + 1.02333			-- A line right across the doorway
		if calcY > yPos then
			calcY = (2.59885 * xPos) - 0.704977
			-- A line at a far end, so as to exclude a bit of the Thorium Brotherhood trader/supply room upstairs as it overlaps
			-- tried a corresponding line for the upstairs room but it overlaps way too much with the downstairs room. This has to do
			if calcY < yPos then
				inTheRemoteRoom = true
			end
		end

		if inTheRemoteRoom then
			if ( BestQuestDB["ETC"]["Direbrew Remote Room"] == nil ) and ( BestQuestDB["ETC"]["The Grim Guzzler"] == nil ) then
				alreadyQueued = false
				for k,v in pairs(BestQuest_Chat) do
					if k == "ETC 16" then
						alreadyQueued = true
						break
					end
				end
				if not alreadyQueued then
					speech["16"] = stringGsub(speech["16"],"~h~", GrimGuzzlerPerformanceTime())
					BestQuest_Chat["ETC 16"] = { ["dialogue"] = speech["16"], ["portrait"] = portrait, ["greeting"] = sound["Lok'tar"],
							["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\GrimGuzzler",
							["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
							["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
							["relativePointY"] = "-110", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "Direbrew Remote Room"}
				end
			end

		else
			if ( BestQuestDB["ETC"]["The Grim Guzzler"] == nil ) then
				alreadyQueued = false
				for k,v in pairs(BestQuest_Chat) do
					if k == "ETC 17" then
						alreadyQueued = true
						break
					end
				end
				if not alreadyQueued then
					speech["17"] = stringGsub(speech["17"],"~h~", GrimGuzzlerPerformanceTime())
					BestQuest_Chat["ETC 17"] = { ["dialogue"] = speech["17"], ["portrait"] = portrait,
							["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\GrimGuzzler",
							["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
							["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
							["relativePointY"] = "-110", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Grim Guzzler"}
				end

				if GetAddOnMetadata("Best_Quest_Explorer","Version") then
					if ( BestQuestDB["Explorer"]["The Grim Guzzler"] ) then
						BestQuestDB["ETC"]["The Grim Guzzler Explorer Reply"] = BESTQUEST_NOT_APPLICABLE
					end
				end

			elseif ( BestQuestDB["ETC"]["The Grim Guzzler Explorer Reply"] == nil ) then

				if GetAddOnMetadata("Best_Quest_Explorer","Version") then
					if ( BestQuestDB["Explorer"]["The Grim Guzzler"] ) then
						alreadyQueued = false
						for k,v in pairs(BestQuest_Chat) do
							if k == "ETC 15" then
								alreadyQueued = true
								break
							end
						end
						if not alreadyQueued then
							speech["15"] = stringGsub(speech["15"],"~n~", BestQuestDB["Explorer"].npcName)
							BestQuest_Chat["ETC 15"] = { ["dialogue"] = speech["15"], ["portrait"] = portrait,
									["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Level80ETC",
									["sizeX"] = "320", ["sizeY"] = "356", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
									["left"]="0.10112", ["right"]="1", ["top"]="0", ["bottom"]="1",
									--["left"]="0.050562", ["right"]="0.949438", ["top"]="0", ["bottom"]="1",
									["relativePointY"] = "-75", ["alpha"] = "0.4", ["DBPrimary"] = "ETC",
									["DBLabel"] = "The Grim Guzzler Explorer Reply"}
							BestQuest_Chat["ETC 15t1"] = { ["greeting"] = sound["IWontForgetThis"], ["showing"] = "ETC 15",
									["startTime"] = 0, ["pause"] = 2, ["DBPrimary"] = "ETC",
									["DBLabel"] = "The Grim Guzzler Explorer Reply t1"}
						end
					end
				end
			end
		end
	end

 	if (subZone == "The Grim Guzzler") and (BestQuestDB["ETC"]["The Grim Guzzler ETC"] == nil) then

		local guID = UnitGUID("target") or 0
		if guID == 0 then return end

		local npcID = select(6, strsplit("-",guID))
		if (npcID == "23619") or		-- Bergrisst
		   (npcID == "23623") or		-- Chief Thunder Skins
		   (npcID == "23624") or		-- Mai'Kyl
		   (npcID == "23625") or		-- Samuro
		   (npcID == "23626") then		-- Sig Nicious

			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 24" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				BestQuest_Chat["ETC 24"] = { ["dialogue"] = speech["24"], ["portrait"] = portrait, ["greeting"] = sound["raspberry8"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\DrumkitGG",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["relativePointY"] = "-110", ["alpha"] = "0.6", ["DBPrimary"] = "ETC", ["DBLabel"] = "The Grim Guzzler ETC"}
				BestQuest_Chat["ETC 24t1"] = { ["greeting"] = sound["raspberry9"], ["showing"] = "ETC 24",
						["startTime"] = 0, ["pause"] = 14, ["DBPrimary"] = "ETC", ["DBLabel"] = "The Grim Guzzler ETC t1"}
				BestQuest_Chat["ETC 24t2"] = { ["greeting"] = sound["Chest waxed"], ["showing"] = "ETC 24",
						["startTime"] = 0, ["pause"] = 16, ["DBPrimary"] = "ETC", ["DBLabel"] = "The Grim Guzzler ETC t2"}
			end
		end
 	end
end

--------------------------------------------------------------------------------------------------------------------------------------------

if tonumber(GetAddOnMetadata("Best_Quest","Version")) < minBQVersion then
	print("\124cFFFF0000Requires Best Quest version \124cFFFFFF00".. minBQVersion.."\124cFFFF0000 or greater")
end

-- ============
--
-- Main Function
--
-- ============

function BestQuest_Functions.ETC()

	if BestQuest_Level < 2 then return end

	if tonumber(GetAddOnMetadata("Best_Quest","Version")) < minBQVersion then
		return
	end

	local alreadyQueued, dbValue = false, ""
	hour, minute = GetGameTime()

	local shattrathOnSoon, shattrathOnNow = false, false
	if ( (hour == 1) or (hour == 5) or (hour == 9) or (hour == 13) or (hour == 17) or (hour == 21) ) and (minute >= 55) then
		shattrathOnSoon = true
	elseif ( (hour == 2) or (hour == 6) or (hour == 10) or (hour == 14) or (hour == 18) or (hour == 22) ) and (minute <= 3) then
		shattrathOnNow = true
	end

	if BestQuestDB["ETC"]["Welcomed"] == nil then
		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 1" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			speech["1"] = stringGsub(speech["1"],"~r~", BestQuest_Race)
			BestQuest_Chat["ETC 1"] = { ["dialogue"] = speech["1"], ["portrait"] = portrait, ["greeting"] = sound["Greetings"], 
							["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Sig&Mai'Kyl",
							["startTime"] = 0, ["pause"] = 30,
							["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
							["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
							["relativePointY"] = "-75", ["alpha"] = "0.4", ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed"}
			BestQuest_Chat["ETC 1f1"] = { ["greeting"] = sound["raspberry3"], ["showing"] = "ETC 1",
					["startTime"] = 0, ["pause"] = 4, ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed f1"}
			BestQuest_Chat["ETC 1f2"] = { ["greeting"] = sound["Zug zug"], ["showing"] = "ETC 1",
					["startTime"] = 0, ["pause"] = 15, ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed f2"}
			BestQuest_Chat["ETC 1f3"] = { ["greeting"] = sound["Gotta do a crap"], ["showing"] = "ETC 1",
					["startTime"] = 0, ["pause"] = 23, ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed f3"}
		end
	elseif BestQuestDB["ETC"]["Welcomed 2"] == nil then
		alreadyQueued = false
		for k,v in pairs(BestQuest_Chat) do
			if k == "ETC 25" then
				alreadyQueued = true
				break
			end
		end
		if not alreadyQueued then
			speech["25"] = stringGsub(speech["25"],"~h~", GrimGuzzlerPerformanceTime())
			BestQuest_Chat["ETC 25"] = { ["dialogue"] = speech["25"], ["portrait"] = portrait,
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\BridgeView",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["relativePointY"] = "-110", ["alpha"] = "0.7", ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed 2"}
			BestQuest_Chat["ETC 25f1"] = { ["greeting"] = sound["Strength and Honour"], ["showing"] = "ETC 25",
						["startTime"] = 0, ["pause"] = 23, ["DBPrimary"] = "ETC", ["DBLabel"] = "Welcomed t1"}
		end

	elseif (BestQuest_AreaID == 463) or (BestQuest_AreaID == 893) or (BestQuest_AreaID == 462) then	-- Ghostlands, Sunstrider Isle, Eversong Woods
		if BestQuestDB["ETC"]["Near Silvermoon"] == nil then
			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 5" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				BestQuest_Chat["ETC 5"] = { ["dialogue"] = speech["5"], ["portrait"] = portrait, ["greeting"] = sound["Hey"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\ChiefThunderSkins",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["relativePointY"] = "-135", ["alpha"] = "0.5", ["DBPrimary"] = "ETC", ["DBLabel"] = "Near Silvermoon"}
				BestQuest_Chat["ETC 5f1"] = { ["greeting"] = sound["raspberry1"], ["showing"] = "ETC 5",
						["startTime"] = 0, ["pause"] = 6, ["DBPrimary"] = "ETC", ["DBLabel"] = "Near Silvermoon f1"}
				BestQuest_Chat["ETC 5f2"] = { ["greeting"] = sound["Stay strong!"], ["showing"] = "ETC 5",
						["startTime"] = 0, ["pause"] = 14, ["DBPrimary"] = "ETC", ["DBLabel"] = "Near Silvermoon f2"}
				BestQuest_Chat["ETC 5f3"] = { ["greeting"] = sound["Always victorious"], ["showing"] = "ETC 5",
						["startTime"] = 0, ["pause"] = 16, ["DBPrimary"] = "ETC", ["DBLabel"] = "Near Silvermoon f3"}
			end
		end

	elseif (BestQuest_AreaID == 480) then								-- Silvermoon City
		if BestQuestDB["ETC"]["Silvermoon"] == nil then
			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 6" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				BestQuest_Chat["ETC 6"] = { ["dialogue"] = speech["6"], ["portrait"] = portrait, ["greeting"] = sound["Not bad"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Mai'Kyl",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["relativePointY"] = "-105", ["alpha"] = "0.5", ["DBPrimary"] = "ETC", ["DBLabel"] = "Silvermoon"}
				BestQuest_Chat["ETC 6t1"] = { ["greeting"] = sound["raspberry2"], ["showing"] = "ETC 6",
						["startTime"] = 0, ["pause"] = 6, ["DBPrimary"] = "ETC", ["DBLabel"] = "Silvermoon t1"}
				BestQuest_Chat["ETC 6t2"] = { ["greeting"] = sound["raspberry4"], ["showing"] = "ETC 6",
						["startTime"] = 0, ["pause"] = 17, ["DBPrimary"] = "ETC", ["DBLabel"] = "Silvermoon t2"}
				BestQuest_Chat["ETC 6t3"] = { ["greeting"] = sound["Feeling feminine"], ["showing"] = "ETC 6",
						["startTime"] = 0, ["pause"] = 19, ["DBPrimary"] = "ETC", ["DBLabel"] = "Silvermoon t3"}
			end
		end
		if BestQuestDB["ETC"]["Near Silvermoon"] == nil then
			BestQuestDB["ETC"]["Near Silvermoon"] = BESTQUEST_NOT_APPLICABLE
		end

	elseif (BestQuest_AreaID == 466) or (BestQuest_AreaID == 475) or (BestQuest_AreaID == 465) or (BestQuest_AreaID == 477) or (BestQuest_AreaID == 479) or
		(BestQuest_AreaID == 473) or (BestQuest_AreaID == 478) or (BestQuest_AreaID == 467) then		-- All of Outlands excluding Shattrath
		if (BestQuestDB["ETC"]["Outlands"] == nil) or ((BestQuestDB["ETC"]["Outlands"] == BESTQUEST_ETC_SHATTRATHNOTREADY) and (shattrathOnSoon or shattrathOnNow)) then

			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 2" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				if shattrathOnSoon then
					factionText = speech["2xf1"]
					dbValue = BESTQUEST_DISPLAYED_MESSAGE
				elseif shattrathOnNow then
					factionText = speech["2xf2"]
					dbValue = BESTQUEST_DISPLAYED_MESSAGE
				else
					factionText = speech["2xf3"]
					dbValue = BESTQUEST_ETC_SHATTRATHNOTREADY
				end
				speech["2"] = stringGsub(speech["2"],"~f~", factionText)
				BestQuest_Chat["ETC 2"] = { ["dialogue"] = speech["2"], ["portrait"] = portrait, ["greeting"] = sound["Zug zug"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\SigNicious",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1", ["DBValue"] = dbValue,
						["relativePointY"] = "-65", ["alpha"] = "1", ["DBPrimary"] = "ETC", ["DBLabel"] = "Outlands"}
				BestQuest_Chat["ETC 2t1"] = { ["greeting"] = sound["raspberry5"], ["showing"] = "ETC 2",
						["startTime"] = 0, ["pause"] = 16, ["DBPrimary"] = "ETC", ["DBLabel"] = "Outlands t1"}
				BestQuest_Chat["ETC 2t2"] = { ["greeting"] = sound["raspberry11"], ["showing"] = "ETC 2",
						["startTime"] = 0, ["pause"] = 18, ["DBPrimary"] = "ETC", ["DBLabel"] = "Outlands t2"}
				BestQuest_Chat["ETC 2t3"] = { ["greeting"] = sound["raspberry11"], ["showing"] = "ETC 2",
						["startTime"] = 0, ["pause"] = 19, ["DBPrimary"] = "ETC", ["DBLabel"] = "Outlands t3"}
				BestQuest_Chat["ETC 2t4"] = { ["greeting"] = sound["raspberry12"], ["showing"] = "ETC 2",
						["startTime"] = 0, ["pause"] = 21, ["DBPrimary"] = "ETC", ["DBLabel"] = "Outlands t4"}
			end
		end

	elseif BestQuest_AreaID == 481 then								-- Shattrath / Worlds End Tavern

		if (BestQuestDB["ETC"]["Shattrath"] == nil) or ((BestQuestDB["ETC"]["Shattrath"] ==
									BESTQUEST_ETC_SHATTRATHNOTREADY) and (shattrathOnSoon or shattrathOnNow)) then

			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 7" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				if shattrathOnSoon then
					factionText = speech["7xf1"]
				elseif shattrathOnNow then
					factionText = speech["7xf2"]
				else
					factionText = speech["7xf3"]
				end
				speech["7"] = stringGsub(speech["7"],"~f1~", factionText)
				if shattrathOnSoon then
					factionText = speech["7xf4"]
					dbValue = BESTQUEST_DISPLAYED_MESSAGE
				elseif shattrathOnNow then
					factionText = speech["7xf5"]
					dbValue = BESTQUEST_DISPLAYED_MESSAGE
				else
					factionText = speech["7xf6"]
					dbValue = BESTQUEST_ETC_SHATTRATHNOTREADY
				end
				speech["7"] = stringGsub(speech["7"],"~f2~", factionText)
				BestQuest_Chat["ETC 7"] = { ["dialogue"] = speech["7"], ["portrait"] = portrait, ["greeting"] = sound["Skillfully done"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Drumset",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1", ["DBValue"] = dbValue,
						["relativePointY"] = "-115", ["alpha"] = "0.85", ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath"}
				BestQuest_Chat["ETC 7t1"] = { ["greeting"] = sound["raspberry6"], ["showing"] = "ETC 7",
						["startTime"] = 0, ["pause"] = 4, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t1"}
				BestQuest_Chat["ETC 7t2"] = { ["greeting"] = sound["raspberry7"], ["showing"] = "ETC 7",
						["startTime"] = 0, ["pause"] = 14, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t2"}
				if shattrathOnNow then
					BestQuest_Chat["ETC 7t3"] = { ["greeting"] = sound["Until next time"], ["showing"] = "ETC 7",
							["startTime"] = 0, ["pause"] = 16, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t3"}
					BestQuest_Chat["ETC 7t4"] = { ["greeting"] = sound["Chop hand off"], ["showing"] = "ETC 7",
							["startTime"] = 0, ["pause"] = 19, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t4"}
				elseif not shattrathOnSoon then
					BestQuest_Chat["ETC 7t3"] = { ["greeting"] = sound["Anything for friend"], ["showing"] = "ETC 7",
							["startTime"] = 0, ["pause"] = 21, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t3"}
					BestQuest_Chat["ETC 7t4"] = { ["greeting"] = sound["D'abu"], ["showing"] = "ETC 7",
							["startTime"] = 0, ["pause"] = 23.5, ["DBPrimary"] = "ETC", ["DBLabel"] = "Shattrath t4"}
				end
			end
		end
		if BestQuestDB["ETC"]["Outlands"] == nil then
			if shattrathOnSoon or shattrathOnNow then
				BestQuestDB["ETC"]["Outlands"] = BESTQUEST_NOT_APPLICABLE
			else
				BestQuestDB["ETC"]["Outlands"] = BESTQUEST_ETC_SHATTRATHNOTREADY
			end
		end


	else
		GrimGuzzler()
	end

	local _,month,today,year = CalendarGetDate()
	local saveMonth, saveYear = CalendarGetMonth()
	local dmfOn = false
	CalendarSetAbsMonth(month,year)
	for i = 1,100 do
		local title,_,_,calendarType,sequenceType = CalendarGetDayEvent(0, today, i)
		if not title then
			break
		end
		if calendarType == "HOLIDAY" then
			if title == CALENDAR_FILTER_DARKMOON then
				if sequenceType == "START" then
					if hour >= 18 then
						dmfOn = true
					end
				elseif sequenceType == "END" then
					if hour < 18 then
						dmfOn = true
					end
				else 
					dmfOn = true
				end
				break
			end
		end
	end
	CalendarSetAbsMonth(saveMonth, saveYear)

	if dmfOn then

		if BestQuestDB["ETC"]["Darkmoon Faire"] == nil then
			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 3" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				if (minute > 55) and (minute < 59) then
					factionText = speech["3xf1"]
				elseif (minute == 59) or (minute < 4) then
					factionText = speech["3xf2"]
				else
					factionText = speech["3xf3"]
				end
				speech["3"] = stringGsub(speech["3"],"~f~", factionText)
				BestQuest_Chat["ETC 3"] = { ["dialogue"] = speech["3"], ["portrait"] = portrait, ["greeting"] = sound["Congratulations"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Samuro",
						["startTime"] = 0, ["pause"] = 30, 
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["relativePointY"] = "-75", ["alpha"] = "0.5", ["DBPrimary"] = "ETC", ["DBLabel"] = "Darkmoon Faire"}
				BestQuest_Chat["ETC 3t1"] = { ["greeting"] = sound["Zug zug flirt"], ["showing"] = "ETC 3",
						["startTime"] = 0, ["pause"] = 15, ["DBPrimary"] = "ETC", ["DBLabel"] = "Darkmoon Faire t1"}
				BestQuest_Chat["ETC 3t2"] = { ["greeting"] = sound["Roar"], ["showing"] = "ETC 3",
						["startTime"] = 0, ["pause"] = 18.5, ["DBPrimary"] = "ETC", ["DBLabel"] = "Darkmoon Faire t2"}
				BestQuest_Chat["ETC 3t3"] = { ["greeting"] = sound["Crazy love"], ["showing"] = "ETC 3",
					["startTime"] = 0, ["pause"] = 20.5, ["DBPrimary"] = "ETC", ["DBLabel"] = "Darkmoon Faire t3"}
				BestQuest_Chat["ETC 3t4"] = { ["greeting"] = sound["raspberry10"], ["showing"] = "ETC 3",
						["startTime"] = 0, ["pause"] = 22.5, ["DBPrimary"] = "ETC", ["DBLabel"] = "Darkmoon Faire t4"}
			end
		end
	end

	if BestQuestDB["ETC"]["Pumped Up"] == nil then
		local pumpedUp = false
		for i=1,40 do
			local spellID = select(11, UnitBuff("player", i))
			if spellID == 42741 then
				pumpedUp = true
				break
			end
		end
		if pumpedUp then
			alreadyQueued = false
			for k,v in pairs(BestQuest_Chat) do
				if k == "ETC 8" then
					alreadyQueued = true
					break
				end
			end
			if not alreadyQueued then
				speech["8"] = stringGsub(speech["8"],"~PvP~", UnitPVPName("player"))
				BestQuest_Chat["ETC 8"] = { ["dialogue"] = speech["8"], ["portrait"] = portrait, ["greeting"] = sound["raspberry13"],
						["artwork"] = "Interface\\AddOns\\Best_Quest_ETC\\Images\\Mai'Kyl2",
						["sizeX"] = "320", ["sizeY"] = "320", ["relativePoint"] = "TOPLEFT", ["relativePointX"] = "22",
						["left"]="0", ["right"]="1", ["top"]="0", ["bottom"]="1",
						["relativePointY"] = "-30", ["alpha"] = "0.8", ["DBPrimary"] = "ETC", ["DBLabel"] = "Pumped Up"}
			end
		end
	end
end